\section{Related Work}
\label{sec:related-work}

\paragraph{Multimedia frameworks} 
FFMpeg \cite{FFmpeg} is the leading multimedia framework, able to decode,
encode, transcode, mux, demux, stream, filter and play pretty much anything. It
is also highly portable. Due to this, it will be our main backend for video and
audio reading. It contains libavcodec, libavutil, libavformat,
libavfilter, libavdevice, libswscale and libswresample which can be used in any
application. We are particularly interested in the libavformat and libavcodec
libraries that we will use for demuxing and decoding an input file.

Media Foundation \cite{MediaFoundation} is a multimedia framework for Windows
that enables the development of applications and components using digital media
on Windows Vista and later. However it does not comply with our cross-platform
requirements. Similarly, AVFoundation \cite{QuickTime} is an extensive
multimedia framework with APIs in Objective-C and Swift, which provides
high-level services for working with time-based audiovisual media on Apple
devices.

\paragraph{Image production and procesing}
OpenCV (Open source Computer Vision library) \cite{OpenCV} is a C/C++ library
for real-time computer vision. As the leader in its field, it is used in many
applications and has become the standard for image processing. Due to the fact
that this is project intends to build knowledge that can be used in other
projects, like a master thesis, it is fundamental to be able to interact with
the standard tools. In this case, we will use OpenCV matrices as our image data
structure and we will also use it in the image processing. Our User Interface
must be able to display OpenCV matrices seamlessly.

There are other libraries that can be used for image processing, like BoofCV
\cite{BoofCV} in Java. However, many of the powerful alternatives use OpenCV in
the implementation, extending and simplifying it.

\paragraph{Audio procesing}
Essentia \cite{essentia} is a C++ library for audio analysis. It contains an
extensive collection algorithms that work in both standard and streaming
applications. It is cross-platform and designed with a focus on optimization in
terms of robustness, computational speed, and low memory usage. This make it a
fairly complex library to integrate in our project.

KFR \cite{KFR} is a modern open source digital signal processing library for C++. Their
Fast Fourier Transform (FFT) is supposedly the fastest according to their
benchmark. However, we faced build problems when trying to use it in our
project, therefore we opted for a simpler solution.

Aquila \cite{Aquila} is a simple cross-platform C++11 library for digital
signal processing. It features easy access to signals from different sources as
well as a small set of algorithms for extracting features from them. Although
it is not well documented, the source code of this library is simple enough to
browse and understand. That is the main reason why we chose it.

\paragraph{GUI frameworks}
Qt \cite{Qt} is a powerful widget toolkit for creating graphical user
interfaces. It is cross-platform and available under both commercial and
open-source licenses. However, commercial applications that use Qt must acquire
a commercial license. FLTK \cite{FLTK} is a fast and lightweight GUI library.
It is cross-platform as well, although it has way less widgets than Qt. This
makes it in exchange simpler. We will be using FLTK version 1.3.8
\cite{libFLTK} due to its simplicity and low overhead.

\paragraph{Multimedia players}
VLC \cite{VLC} is a highly portable multimedia player for various audio and
video formats and streaming protocols. It uses many libraries for
decoding/encoding video and audio but one of the most used is FFMpeg. Although
it has served as inspiration, the fact that it uses Qt as GUI framework and the
raw size of the codebase makes difficult to check how they solved the
challenges that this work has faced. 

\paragraph{Audio visualizing tools}
Sonic Visualizer \cite{SonicVisualizer} is a reference audio visualizer where
the user can visualize the audio spectrum, the waveform, etc. It is
cross-platform as well and allows for users to develop plugins using Vamp
\cite{Vamp} in order to make custom visualizations from audio data. The
modularity and flexibility of Sonic Visualizer makes it the reference software
for our audiovisual visualizer. Although, due to its complexity, most of their
features are out of the scope for this work.

